#include <boost/lexical_cast.hpp>
#include <boost/algorithm/string.hpp>
#include "model.h"
#include "http_json_handler.h"
#include "http/request.hpp"
#include "http/reply.hpp"

namespace ZRouter {

using namespace http;
using namespace http::server;
using namespace std;

http_json_handler::http_json_handler(Model::Model &p_model)
	:model(p_model) {

}

const std::string http_json_handler::ns_prefix() {
	return "/model/";
}

const handlers::e_request_handler_type http_json_handler::type() {
	return handlers::NORMAL;
}
const bool http_json_handler::can_handle(const server::request& req) {
	//cout << "can_handle: " << req.uri << " : " << req.uri.find("/model/") << endl;
	if (req.uri.find(ns_prefix()) != 0) {
	//	cout << "Not our thing" << endl;
		return false;
	}
	return true;
}
void http_json_handler::handle(const server::request& req, server::reply& rep) {
  // Fill out the reply to be sent to the client.
	std::vector<std::string> uri_parts;
	boost::split(uri_parts,  req.uri, boost::is_any_of("/"));

	cout << "Handling request for << " << uri_parts[1] << ":" << uri_parts[2] << endl;	
  rep.status = reply::ok;
	std::string resp = json_spirit::write(model);
	rep.content.append(resp.c_str(), resp.length());
  rep.headers.resize(2);
  rep.headers[0].name = "Content-Length";
  rep.headers[0].value = boost::lexical_cast<std::string>(rep.content.size());
  //rep.headers[0].value = "20";
  rep.headers[1].name = "Content-Type";
  //rep.headers[1].value = mime_types::extension_to_type(extension);
  rep.headers[1].value = "application/json; lang=utf8";
}

}
