#ifndef __INTERFACES__H
#define __INTERFACES__H


namespace ZRouter {
	class ZFrame;

   // abstract base class
   class ePacketReceivedFunctor
   {
   public:

      // two possible functions to call member function. virtual cause derived
      // classes will use a pointer to an object and a pointer to a member function
      // to make the function call
      virtual bool operator()(const ZFrame &pFrame )=0;  // call using operator
      virtual bool Call(const ZFrame &pFrame)=0;        // call using function
   };

	class iFrameLayer {
		public:
			virtual void queue_cmd(const ZFrame &p) = 0;
			virtual void addListener(ePacketReceivedFunctor* pListener) = 0;
			virtual void setIdle(bool pIdle) = 0;
	};
	class iEngine {
		public:
			virtual iFrameLayer* framelayer() = 0;
	};

};
#endif // __INTERFACES__H
