/* TODO:
	Add License
	Make write support
	Parse kenv correctly into real tree model
*/

extern "C" {
	#include <sys/cdefs.h>

	#include <sys/types.h>
	#include <sys/sysctl.h>
	#include <err.h>
	#include <kenv.h>
}

#include "../zextension.h"
// #include "../model.h"

using namespace json_spirit;
using namespace ZRouter;
using namespace std;

/* Hack: This is just a "read-only" module adding kenv to object model under state.kernel_environment
 */

mObject kdumpenv(void);

class Platform_FreeBSD_KEnv_Module {
	public:
	Platform_FreeBSD_KEnv_Module() {
		std::cout << "Registering module foo" << std::endl;
		ZExtensionManager::register_extension("Platform_FreeBSD_KEnv_Module", extension_init);
		std::cout << "Registering module foo done" << std::endl;
	}
	static bool extension_init(boost::asio::io_service &io, Model &model) {
		cout << "Init of module ZEngine" << endl;
		
		model["state"].get_obj()["kernel_environment"]=kdumpenv();
		return true;
	}
} _module;


mObject kdumpenv(void) {
	mObject retval;
	char *buf, *cp;
	int buflen, envlen;

	envlen = kenv(KENV_DUMP, NULL, NULL, 0);
	if (envlen < 0)
		return retval;
	for (;;) {
		buflen = envlen * 120 / 100;
		buf = new char[buflen + 1];
		if (buf == NULL)
			return retval;
		memset(buf, 0, buflen + 1);	/* Be defensive */
		envlen = kenv(KENV_DUMP, NULL, buf, buflen);
		if (envlen < 0) {
			free(buf);
			return retval;
		}
		if (envlen > buflen)
			free(buf);
		else
			break;
	}

	for (; *buf != '\0'; buf += strlen(buf) + 1) {
		cp = strchr(buf, '=');
		if (cp == NULL)
			continue;
		*cp++ = '\0';
		printf("%s=\"%s\"\n", buf, cp);
		retval[buf] = cp;
		buf = cp;
	}
	return retval;
}


